## libtheora 1.2.0~alpha1+dfsg

=== SConstruct ===
# see http://www.scons.org if you do not have this tool
from os.path import join
import SCons

# TODO: should use lamda and map to work on python 1.5
def path(prefix, list): return [join(prefix, x) for x in list]

encoder_sources = """
	apiwrapper.c
	fragment.c
	idct.c
	internal.c
	state.c
	quant.c
	analyze.c
	encfrag.c
	encapiwrapper.c
	encinfo.c
	encode.c
	enquant.c
	fdct.c
	huffenc.c
	mathops.c
	mcenc.c
	rate.c
	tokenize.c
"""

decoder_sources = """
        apiwrapper.c
	bitpack.c
        decapiwrapper.c
        decinfo.c
        decode.c
        dequant.c
        fragment.c
        huffdec.c
        idct.c
        info.c
        internal.c
        quant.c
        state.c
"""

env = Environment()
if env['CC'] == 'gcc':
  env.Append(CCFLAGS=["-g", "-O2", "-Wall", "-Wno-parentheses"])

def CheckPKGConfig(context, version): 
  context.Message( 'Checking for pkg-config... ' ) 
  ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0] 
  context.Result( ret ) 
  return ret 

def CheckPKG(context, name): 
  context.Message( 'Checking for %s... ' % name )
  ret = context.TryAction('pkg-config --exists %s' % name)[0]
  context.Result( ret ) 
  return ret
     
def CheckSDL(context):
  name = "sdl-config"
  context.Message( 'Checking for %s... ' % name )
  ret = SCons.Util.WhereIs('sdl-config')
  context.Result( ret ) 
  return ret

# check for appropriate inline asm support
host_x86_32_test = """
    int main(int argc, char **argv) {
#if !defined(__i386__)
  #error not an x86 host: preprocessor macro __i386__ not defined
#endif
  return 0;
    }
    """
def CheckHost_x86_32(context):
  context.Message('Checking for an x86 host...')
  result = context.TryCompile(host_x86_32_test, '.c')
  context.Result(result)
  return result

host_x86_64_test = """
    int main(int argc, char **argv) {
#if !defined(__x86_64__)
  #error not an x86_64 host: preprocessor macro __x86_64__ not defined
#endif
  return 0;
    }
    """
def CheckHost_x86_64(context):
  context.Message('Checking for an x86_64 host...')
  result = context.TryCompile(host_x86_64_test, '.c')
  context.Result(result)
  return result

conf = Configure(env, custom_tests = {
  'CheckPKGConfig' : CheckPKGConfig,
  'CheckPKG' : CheckPKG,
  'CheckSDL' : CheckSDL,
  'CheckHost_x86_32' : CheckHost_x86_32,
  'CheckHost_x86_64' : CheckHost_x86_64,
  })
  
if not conf.CheckPKGConfig('0.15.0'): 
   print 'pkg-config >= 0.15.0 not found.' 
   Exit(1)

if not conf.CheckPKG('ogg'): 
  print 'libogg not found.' 
  Exit(1) 

if conf.CheckPKG('vorbis vorbisenc'):
  have_vorbis=True
else:
  have_vorbis=False

if conf.CheckPKG('libpng'):
  have_libpng=True
else:
  have_libpng=False
  
build_player_example=True
if not conf.CheckHeader('sys/soundcard.h'):
  build_player_example=False
if build_player_example and not conf.CheckSDL():
  build_player_example=False

if conf.CheckHost_x86_32():
  env.Append(CPPDEFINES='OC_X86_ASM')
  decoder_sources += """
        x86/x86cpu.c
        x86/mmxidct.c
        x86/mmxfrag.c
        x86/mmxstate.c
        x86/sse2idct.c
        x86/x86state.c
  """
  encoder_sources += """
        x86/x86cpu.c
        x86/mmxencfrag.c
        x86/mmxfdct.c
        x86/x86enc.c
        x86/x86enquant.c
        x86/sse2encfrag.c
        x86/mmxfrag.c
        x86/mmxidct.c
        x86/mmxstate.c
        x86/x86state.c
  """
elif conf.CheckHost_x86_64():
  env.Append(CPPDEFINES=['OC_X86_ASM', 'OC_X86_64_ASM'])
  decoder_sources += """
        x86/x86cpu.c
        x86/mmxidct.c
        x86/mmxfrag.c
        x86/mmxstate.c
        x86/sse2idct.c
        x86/x86state.c
  """
  encoder_sources += """
        x86/x86cpu.c
        x86/mmxencfrag.c
        x86/mmxfdct.c
        x86/x86enc.c
        x86/x86enquant.c
        x86/sse2fdct.c
        x86/mmxfrag.c
        x86/mmxidct.c
        x86/mmxstate.c
        x86/x86state.c
        x86/sse2encfrag.c
  """

env = conf.Finish()

env.Append(CPPPATH=['include'])
env.ParseConfig('pkg-config --cflags --libs ogg')

libtheoradec_Sources = Split(decoder_sources)
libtheoraenc_Sources = Split(encoder_sources)

libtheoradec_a = env.Library('lib/theoradec',
	path('lib', libtheoradec_Sources))
libtheoradec_so = env.SharedLibrary('lib/theoradec',
	path('lib', libtheoradec_Sources))

libtheoraenc_a = env.Library('lib/theoraenc',
	path('lib', libtheoraenc_Sources))
libtheoraenc_so = env.SharedLibrary('lib/theoraenc',
	path('lib', libtheoraenc_Sources) + [libtheoradec_so])

#installing
prefix='/usr'
lib_dir = prefix + '/lib'
env.Alias('install', prefix)
env.Install(lib_dir, [libtheoradec_a, libtheoradec_so])
env.Install(lib_dir, [libtheoraenc_a, libtheoraenc_so])

# example programs
dump_video = env.Clone()
dump_video_Sources = Split("""dump_video.c ../lib/libtheoradec.a""")
dump_video.Program('examples/dump_video', path('examples', dump_video_Sources))

dump_psnr = env.Clone()
dump_psnr.Append(LIBS='m')
dump_psnr_Sources = Split("""dump_psnr.c ../lib/libtheoradec.a""")
dump_psnr.Program('examples/dump_psnr', path('examples', dump_psnr_Sources))

if have_vorbis:
  encex = dump_video.Clone()
  encex.ParseConfig('pkg-config --cflags --libs vorbisenc vorbis')
  encex.Append(LIBS=['m'])
  encex_Sources = Split("""
	encoder_example.c
	../lib/libtheoraenc.a 
	../lib/libtheoradec.a
  """)
  encex.Program('examples/encoder_example', path('examples', encex_Sources))

  if build_player_example:
    plyex = encex.Clone()
    plyex_Sources = Split("""
	player_example.c
	../lib/libtheoradec.a
    """)
    plyex.ParseConfig('sdl-config --cflags --libs')
    plyex.Append(LIBS=['m'])
    plyex.Program('examples/player_example', path('examples', plyex_Sources))

png2theora = env.Clone()
png2theora_Sources = Split("""png2theora.c
	../lib/libtheoraenc.a
	../lib/libtheoradec.a
""")
png2theora.ParseConfig('pkg-config --cflags --libs libpng')
png2theora.Append(LIBS=['m'])
png2theora.Program('examples/png2theora', path('examples', png2theora_Sources))

=== debian/changelog ===
libtheora (1.2.0~alpha1+dfsg-5) unstable; urgency=medium

  * Team upload
  * debian/clean: Clean documentation (Closes: #1048962)
  * debian/tests: Skip valgrind test on armhf due to spurious errors.
    valgrind fails with a hardened build of libtheora but it is impossible to
    reproduce the issue with other tools.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 16 Jan 2025 23:39:37 +0100

libtheora (1.2.0~alpha1+dfsg-4) unstable; urgency=medium

  * Team upload
  * debian/rules: Also disable NEON optimizations on armhf to fix runtime
    crashes

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 15 Jan 2025 19:15:30 +0100

libtheora (1.2.0~alpha1+dfsg-3) unstable; urgency=medium

  * Team upload
  * Disable NEON optimizations on armel

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 14 Jan 2025 23:17:08 +0100

libtheora (1.2.0~alpha1+dfsg-2) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 14 Jan 2025 08:26:58 +0100

libtheora (1.2.0~alpha1+dfsg-1) experimental; urgency=medium

  * Team upload
  * New upstream version 1.2.0~alpha1+dfsg
  * debin/: Split off libraries with differing SOVERSION
  * debian/patches: Update patches for 1.2.0~alpha1
  * debian/watch: Specify repacksuffix
  * debian/copyright: Extend with missing copyright information
  * debian/libtheore-doc.docs: Update for changed paths

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 29 Dec 2024 17:49:20 +0100

libtheora (1.1.1+dfsg.1-17) unstable; urgency=medium

  * Team upload
  * Acknowledge NMU (Closes: #1024649)
  * debian/control:
    - Bump Standards-Version
    - Set RRR: no
    - Use pkgconf
  * debian/: Break build cycle with libsdl1.2 (Closes: #1077536)
  * debian/patches: Fix underlinking of libtheoraenc (Closes: #923940)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 11 Aug 2024 13:29:24 +0200

=== debian/control ===
Source: libtheora
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Petter Reinholdtsen <pere@debian.org>,
 Martin Steghöfer <martin@steghoefer.eu>,
 Ralph Giles <giles@thaumas.net>,
Build-Depends:
 debhelper-compat (= 13),
 doxygen,
 libcairo2-dev,
 libogg-dev,
 libpng-dev,
 libsdl1.2-dev <!pkg.libtheora.nosdl>,
 libvorbis-dev,
 pkgconf,
Build-Depends-Indep:
 ghostscript,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-latex-recommended,
 transfig,
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/multimedia-team/libtheora.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libtheora
Homepage: https://www.theora.org/
Rules-Requires-Root: no

Package: libtheora-bin
Architecture: any
Build-Profiles: <!pkg.libtheora.nosdl>
Section: utils
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Theora Video Compression Codec (example encoder, decoder)
 Theora is a fully open, non-proprietary, patent-and-royalty-free,
 general-purpose compressed video format.
 .
 This package contains a reference implementation of an encoder and a
 decoder.

Package: libtheora-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libogg-dev,
 libtheora0 (= ${binary:Version}),
 libtheoradec1 (= ${binary:Version}),
 libtheoraenc1 (= ${binary:Version}),
 ${misc:Depends},
Description: Theora Video Compression Codec (development files)
 Theora is a fully open, non-proprietary, patent-and-royalty-free,
 general-purpose compressed video format.
 .
 This package contains the header files needed to develop applications
 with libtheora.

Package: libtheora-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 libtheora-dev,
Description: Theora Video Compression Codec (documentation)
 Theora is a fully open, non-proprietary, patent-and-royalty-free,
 general-purpose compressed video format.
 .
 This package contains the documentation about the format and programming.

Package: libtheora0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libtheoradec1 (= ${binary:Version}),
 libtheoraenc1 (= ${binary:Version}),
Description: Theora Video Compression Codec (shared library - libtheora)
 Theora is an open video codec being developed by the Xiph.org Foundation as
 part of their Ogg project. Theora is originally derived from On2's VP3 codec,
 and has improved on it significantly with the merging of code from the
 Thusnelda branch.
 .
 This package contains the shared library libtheora.

Package: libtheoraenc1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libtheora0 (<< 1.2.0~alpha1+dfsg-1),
Replaces:
 libtheora0 (<< 1.2.0~alpha1+dfsg-1),
Description: Theora Video Compression Codec (shared library - libtheoraenc)
 Theora is an open video codec being developed by the Xiph.org Foundation as
 part of their Ogg project. Theora is originally derived from On2's VP3 codec,
 and has improved on it significantly with the merging of code from the
 Thusnelda branch.
 .
 This package contains the shared library libtheoraenc.

Package: libtheoradec1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libtheora0 (<< 1.2.0~alpha1+dfsg-1),
Replaces:
 libtheora0 (<< 1.2.0~alpha1+dfsg-1),
Description: Theora Video Compression Codec (shared library - libtheoradec)
 Theora is an open video codec being developed by the Xiph.org Foundation as
 part of their Ogg project. Theora is originally derived from On2's VP3 codec,
 and has improved on it significantly with the merging of code from the
 Thusnelda branch.
 .
 This package contains the shared library libtheoradec.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Ensure texlive respects SOURCE_DATE_EPOCH
export FORCE_SOURCE_DATE=1

# Enable Telemetry debugging information (LP: #627854), see
# <URL: https://people.xiph.org/~xiphmont/demo/theora/demo2.html >
CONFIGURE_FLAGS = --enable-telemetry
ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
CONFIGURE_FLAGS += --disable-asm
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

ifeq (,$(filter pkg.libtheora.nosdl,$(DEB_BUILD_PROFILES)))
execute_after_dh_install-arch:
	for i in debian/libtheora-bin/usr/bin/*; do \
		mv $$i debian/libtheora-bin/usr/bin/theora_`basename $$i`; \
	done
endif

override_dh_autoreconf:
	dh_autoreconf autoreconf -- -i -f -I m4

## libtheora 1.2.0%2Bdfsg

=== debian/changelog ===
libtheora (1.2.0+dfsg-6) unstable; urgency=medium

  * Team upload
  * debian/control: Drop left-over Depends+Breaks+Replaces (Closes: #1113790)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 06 Sep 2025 15:52:30 +0200

libtheora (1.2.0+dfsg-5) unstable; urgency=medium

  * Upload to unstable.
  * Dropped old FSF address from d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 30 Aug 2025 21:20:01 +0200

libtheora (1.2.0+dfsg-4) experimental; urgency=medium

  * Team upload.

  * Added 0002-arm-missing-files.patch for files needed on armhf.
  * Reintroduce --disable-asm for armel, as 1.2.0 assembly do not
    work there.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 02 Apr 2025 18:18:20 +0200

libtheora (1.2.0+dfsg-3) experimental; urgency=medium

  * Team upload.

  * Stop disabling use of asm on arm as it should be working in 1.2.0.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 02 Apr 2025 16:23:29 +0200

libtheora (1.2.0+dfsg-2) experimental; urgency=medium

  * Team upload.

  * Source only upload after NEW processing.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 29 Mar 2025 21:08:16 +0100

libtheora (1.2.0+dfsg-1) experimental; urgency=medium

  * Team upload.

  * New upstream version 1.2.0.
   - SONAME change for libtheora0->libtheora1,
     libtheoradec1->libtheoradec2 and libtheoraenc1->libtheoraenc2 due
     to changes in constness for string arguments of some public
     method arguments.
   - README now i markdown format.
   - Include encoding wrapper script (Closes: #516343).
   - Fixes performance issue when enabling telemetry (Closes: #972943).
   - Dropped 0002-player-example-needs-lm-for-rint.patch,
     0003-latex.patch, 0004-libpng16.patch,
     0005-drop-inter-library-dep.patch and 0006-CVE-2024-56431.patch
     now included upstream.
  * Dropped autopkgtest dependency valgrind on armel and riscv64.
  * Updated Standards-Version from 4.7.0 to 4.7.2.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 29 Mar 2025 10:15:44 +0100

libtheora (1.2.0~alpha1+dfsg-6) unstable; urgency=medium

  * Team upload.

  * Added 0005-drop-inter-library-dep.patch from upstream to avoid
    unwanted library dependency (Closes: #923940).
  * Added 0006-CVE-2024-56431.patch fixing crash on bad input
    (Closes: #1091633).

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 16 Mar 2025 04:59:38 +0100

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # Enable Telemetry debugging information (LP: #627854), see
 # <URL: https://people.xiph.org/~xiphmont/demo/theora/demo2.html >
 CONFIGURE_FLAGS = --enable-telemetry
-ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf))
+ifneq (,$(filter $(DEB_HOST_ARCH), armel))
 CONFIGURE_FLAGS += --disable-asm
 endif

## libtheora 1.2.0+dfsg

=== SConstruct ===
--- 
+++ 
@@ -1,8 +1,8 @@
-# see http://www.scons.org if you do not have this tool
+# see https://www.scons.org if you do not have this tool
 from os.path import join
 import SCons
 
-# TODO: should use lamda and map to work on python 1.5
+# TODO: should use lambda and map to work on python 1.5
 def path(prefix, list): return [join(prefix, x) for x in list]
 
 encoder_sources = """
@@ -46,6 +46,13 @@
 if env['CC'] == 'gcc':
   env.Append(CCFLAGS=["-g", "-O2", "-Wall", "-Wno-parentheses"])
 
+# pass collect_metrics=1 on the scons command line
+# to enable metrics collection for mode training.
+collect_metrics = ARGUMENTS.get('collect_metrics', 0)
+if int(collect_metrics):
+  env.Append(CPPDEFINES=['OC_COLLECT_METRICS'])
+  env.Append(LIBS=['m'])
+
 def CheckPKGConfig(context, version): 
   context.Message( 'Checking for pkg-config... ' ) 
   ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0] 
@@ -94,20 +101,35 @@
   context.Result(result)
   return result
 
+clock_gettime_test = """
+#    include <time.h>
+    int main(int argc, char **argv) {
+      struct timespec ts;
+      return clock_gettime(CLOCK_REALTIME, &ts);
+      return 0;
+    }
+    """
+def CheckClock_GetTime(context):
+  context.Message('Checking for clock_gettime...')
+  result = context.TryCompile(clock_gettime_test, '.c')
+  context.Result(result)
+  return result
+
 conf = Configure(env, custom_tests = {
   'CheckPKGConfig' : CheckPKGConfig,
   'CheckPKG' : CheckPKG,
   'CheckSDL' : CheckSDL,
   'CheckHost_x86_32' : CheckHost_x86_32,
   'CheckHost_x86_64' : CheckHost_x86_64,
+  'CheckClock_GetTime' : CheckClock_GetTime,
   })
-  
+
 if not conf.CheckPKGConfig('0.15.0'): 
-   print 'pkg-config >= 0.15.0 not found.' 
-   Exit(1)
+  print('pkg-config >= 0.15.0 not found.')
+  Exit(1)
 
 if not conf.CheckPKG('ogg'): 
-  print 'libogg not found.' 
+  print('libogg not found.')
   Exit(1) 
 
 if conf.CheckPKG('vorbis vorbisenc'):
@@ -172,6 +194,9 @@
         x86/sse2encfrag.c
   """
 
+if conf.CheckClock_GetTime():
+  env.Append(CPPDEFINES='OP_HAVE_CLOCK_GETTIME')
+
 env = conf.Finish()
 
 env.Append(CPPPATH=['include'])
@@ -206,6 +231,15 @@
 dump_psnr.Append(LIBS='m')
 dump_psnr_Sources = Split("""dump_psnr.c ../lib/libtheoradec.a""")
 dump_psnr.Program('examples/dump_psnr', path('examples', dump_psnr_Sources))
+
+libtheora_info = env.Clone()
+libtheora_info_Sources = Split("""
+        libtheora_info.c
+        ../lib/libtheoraenc.a
+        ../lib/libtheoradec.a
+  """)
+libtheora_info.Program('examples/libtheora_info',
+                       path('examples', libtheora_info_Sources))
 
 if have_vorbis:
   encex = dump_video.Clone()
@@ -237,3 +271,10 @@
 png2theora.Append(LIBS=['m'])
 png2theora.Program('examples/png2theora', path('examples', png2theora_Sources))
 
+tiff2theora = env.Clone()
+tiff2theora_Sources = Split("""tiff2theora.c
+        ../lib/libtheoraenc.a
+        ../lib/libtheoradec.a
+""")
+tiff2theora.Append(LIBS=['tiff', 'm'])
+tiff2theora.Program('examples/tiff2theora', path('examples', tiff2theora_Sources))

=== win32/xmingw32/Makefile ===
# NOTE: This Makefile requires GNU make
# Location to put the targets.
TARGETBINDIR = .
TARGETLIBDIR = .
# DLL version information. Currently this must be updated manually.
# Fields are: major, minor, build number, QFE version
VERSION_FIELD = 1,0,0,0
VERSION_STRING = \\\"1.0\\\"
# Name of the targets
# Hooray for Windows DLL hell.
LIBTHEORAENC_TARGET = libtheoraenc.dll
LIBTHEORAENCD_TARGET = libtheoraencd.dll
LIBTHEORAENC70_TARGET = libtheoraenc70.dll
LIBTHEORAENC70D_TARGET = libtheoraenc70d.dll
LIBTHEORAENC71_TARGET = libtheoraenc71.dll
LIBTHEORAENC71D_TARGET = libtheoraenc71d.dll
LIBTHEORAENC80_TARGET = libtheoraenc80.dll
LIBTHEORAENC80D_TARGET = libtheoraenc80d.dll

LIBTHEORADEC_TARGET = libtheoradec.dll
LIBTHEORADECD_TARGET = libtheoradecd.dll
LIBTHEORADEC70_TARGET = libtheoradec70.dll
LIBTHEORADEC70D_TARGET = libtheoradec70d.dll
LIBTHEORADEC71_TARGET = libtheoradec71.dll
LIBTHEORADEC71D_TARGET = libtheoradec71d.dll
LIBTHEORADEC80_TARGET = libtheoradec80.dll
LIBTHEORADEC80D_TARGET = libtheoradec80d.dll

DUMP_VIDEO_TARGET = dump_video.exe
PLAYER_EXAMPLE_TARGET = player_example.exe
ENCODER_EXAMPLE_TARGET = encoder_example.exe

# The compiler tools to use
# The is no standard mingw prefix, so try to guess
MINGW_PREFIX := $(or $(strip $(foreach exeprefix, \
	i686-mingw32 i686-pc-mingw32 i586-mingw32msvc i386-mingw32 \
	no-mingw32, \
	$(if $(shell which $(exeprefix)-gcc 2>/dev/null), $(exeprefix) ))))
CC = $(MINGW_PREFIX)-gcc
RC = $(MINGW_PREFIX)-windres
DLLTOOL = $(MINGW_PREFIX)-dlltool
LD = $(MINGW_PREFIX)-ld
SDLCONFIG = $(MINGW_PREFIX)-sdl-config
# The command to use to generate dependency information
MAKEDEPEND = ${CC} -MM
#MAKEDEPEND = makedepend -f- -Y --

# The location of include files.
# Modify these to point to your Ogg and Vorbis include directories if they are
#  not installed in a standard location.
CINCLUDE = -D_REENTRANT
# Extra compilation flags.
# You may get speed increases by including flags such as -O2 or -O3 or
#  -ffast-math, or additional flags, depending on your system and compiler.
# The correct -march=<architecture> flag will also generate much better code
#  on newer architectures.
CFLAGS = -Wall -Wno-parentheses -DOC_X86_ASM
RELEASE_CFLAGS = ${CFLAGS} -mtune=native -O3 -fomit-frame-pointer -fforce-addr \
 -finline-functions
# The -g flag will generally include debugging information.
DEBUG_CFLAGS = ${CFLAGS} -g
# Libraries to link with, and the location of library files.
LIBS = -logg -lvorbis -lvorbisenc

# ANYTHING BELOW THIS LINE PROBABLY DOES NOT NEED EDITING
CINCLUDE := -I../../include ${CINCLUDE}
LIBSRCDIR = ../../lib
BINSRCDIR = ../../examples
WORKDIR = objs

# C source file lists

LIBTHEORADEC_CSOURCES = \
apiwrapper.c \
bitpack.c \
decapiwrapper.c \
decinfo.c \
decode.c \
dequant.c \
fragment.c \
huffdec.c \
idct.c \
info.c \
internal.c \
quant.c \
state.c \
$(if $(findstring -DOC_X86_ASM,${CFLAGS}), \
x86/mmxidct.c \
x86/mmxfrag.c \
x86/mmxstate.c \
x86/x86state.c \
)

LIBTHEORAENC_CSOURCES = \
apiwrapper.c \
fragment.c \
idct.c \
internal.c \
state.c \
quant.c \
analyze.c \
fdct.c \
encfrag.c \
encapiwrapper.c \
encinfo.c \
encode.c \
enquant.c \
huffenc.c \
mathops.c \
mcenc.c \
rate.c \
tokenize.c \
$(if $(findstring -DOC_X86_ASM,${CFLAGS}), \
x86/mmxfrag.c \
x86/mmxidct.c \
x86/mmxstate.c \
x86/x86state.c \
x86/mmxencfrag.c \
x86/mmxfdct.c \
x86/x86enc.c \
)


DUMP_VIDEO_CSOURCES = dump_video.c
ENCODER_EXAMPLE_CSOURCES = encoder_example.c
PLAYER_EXAMPLE_CSOURCES = player_example.c

# Create object file list.
LIBTHEORADEC_OBJS:= ${LIBTHEORADEC_CSOURCES:%.c=${WORKDIR}/%.o}
LIBTHEORADECD_OBJS:= ${LIBTHEORADEC_CSOURCES:%.c=${WORKDIR}/%.do}
LIBTHEORAENC_OBJS:=  ${LIBTHEORAENC_CSOURCES:%.c=${WORKDIR}/%.o}
LIBTHEORAENCD_OBJS:= ${LIBTHEORAENC_CSOURCES:%.c=${WORKDIR}/%.do}
DUMP_VIDEO_OBJS:= ${DUMP_VIDEO_CSOURCES:%.c=${WORKDIR}/%.o}
ENCODER_EXAMPLE_OBJS:= ${ENCODER_EXAMPLE_CSOURCES:%.c=${WORKDIR}/%.o}
PLAYER_EXAMPLE_OBJS:= ${PLAYER_EXAMPLE_CSOURCES:%.c=${WORKDIR}/%.o}
RC_OBJS:= ${LIBTHEORADEC_TARGET} ${LIBTHEORAENC_TARGET} \
 ${LIBTHEORADECD_TARGET} ${LIBTHEORAENCD_TARGET} \
 ${LIBTHEORADEC70_TARGET} ${LIBTHEORAENC70_TARGET} \
 ${LIBTHEORADEC70D_TARGET} ${LIBTHEORAENC70D_TARGET} \
 ${LIBTHEORADEC71_TARGET} ${LIBTHEORAENC71_TARGET} \
 ${LIBTHEORADEC71D_TARGET} ${LIBTHEORAENC71D_TARGET} \
 ${LIBTHEORADEC80_TARGET} ${LIBTHEORAENC80_TARGET} \
 ${LIBTHEORADEC80D_TARGET} ${LIBTHEORAENC80D_TARGET}
RC_OBJS:= ${RC_OBJS:%.dll=${WORKDIR}/%.rco}
ALL_OBJS:= ${LIBTHEORADEC_OBJS} ${LIBTHEORAENC_OBJS} \
 ${LIBTHEORADECD_OBJS} ${LIBTHEORAENCD_OBJS} ${RC_OBJS} \
 ${DUMP_VIDEO_OBJS} ${ENCODER_EXAMPLE_OBJS} #${PLAYER_EXAMPLE_OBJS}
# Create the dependency file list
ALL_DEPS:= ${ALL_OBJS:%.o=%.d}
ALL_DEPS:= ${ALL_DEPS:%.do=%.dd}
ALL_DEPS:= ${ALL_DEPS:%.rco=%.d}
# Prepend source path to file names.
LIBTHEORADEC_CSOURCES:= ${LIBTHEORADEC_CSOURCES:%=${LIBSRCDIR}/%}
LIBTHEORAENC_CSOURCES:= ${LIBTHEORAENC_CSOURCES:%=${LIBSRCDIR}/%}
DUMP_VIDEO_CSOURCES:= ${DUMP_VIDEO_CSOURCES:%=${BINSRCDIR}/%}
ENCODER_EXAMPLE_CSOURCES:= ${ENCODER_EXAMPLE_CSOURCES:%=${BINSRCDIR}/%}
PLAYER_EXAMPLE_CSOURCES:= ${PLAYER_EXAMPLE_CSOURCES:%=${BINSRCDIR}/%}
ALL_CSOURCES:= ${LIBTHEORADEC_CSOURCES} ${LIBTHEORAENC_CSOURCES} \
 ${DUMP_VIDEO_CSOURCES} ${PLAYER_EXAMPLE_CSOURCES} \
 ${ENCODER_EXAMPLE_CSOURCES}
LIBTHEORAENC_RCO:= ${WORKDIR}/${LIBTHEORAENC_TARGET:%.dll=%.rco}
LIBTHEORAENCD_RCO:= ${WORKDIR}/${LIBTHEORAENCD_TARGET:%.dll=%.rco}
LIBTHEORAENC70_RCO:= ${WORKDIR}/${LIBTHEORAENC70_TARGET:%.dll=%.rco}
LIBTHEORAENC70D_RCO:= ${WORKDIR}/${LIBTHEORAENC70D_TARGET:%.dll=%.rco}
LIBTHEORAENC71_RCO:= ${WORKDIR}/${LIBTHEORAENC71_TARGET:%.dll=%.rco}
LIBTHEORAENC71D_RCO:= ${WORKDIR}/${LIBTHEORAENC71D_TARGET:%.dll=%.rco}
LIBTHEORAENC80_RCO:= ${WORKDIR}/${LIBTHEORAENC80_TARGET:%.dll=%.rco}
LIBTHEORAENC80D_RCO:= ${WORKDIR}/${LIBTHEORAENC80D_TARGET:%.dll=%.rco}
LIBTHEORADEC_RCO:= ${WORKDIR}/${LIBTHEORADEC_TARGET:%.dll=%.rco}
LIBTHEORADECD_RCO:= ${WORKDIR}/${LIBTHEORADECD_TARGET:%.dll=%.rco}
LIBTHEORADEC70_RCO:= ${WORKDIR}/${LIBTHEORADEC70_TARGET:%.dll=%.rco}
LIBTHEORADEC70D_RCO:= ${WORKDIR}/${LIBTHEORADEC70D_TARGET:%.dll=%.rco}
LIBTHEORADEC71_RCO:= ${WORKDIR}/${LIBTHEORADEC71_TARGET:%.dll=%.rco}
LIBTHEORADEC71D_RCO:= ${WORKDIR}/${LIBTHEORADEC71D_TARGET:%.dll=%.rco}
LIBTHEORADEC80_RCO:= ${WORKDIR}/${LIBTHEORADEC80_TARGET:%.dll=%.rco}
LIBTHEORADEC80D_RCO:= ${WORKDIR}/${LIBTHEORADEC80D_TARGET:%.dll=%.rco}
# Prepend target path to file names.
LIBTHEORAENC_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENC_TARGET}
LIBTHEORAENCD_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENCD_TARGET}
LIBTHEORAENC70_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENC70_TARGET}
LIBTHEORAENC70D_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENC70D_TARGET}
LIBTHEORAENC71_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENC71_TARGET}
LIBTHEORAENC71D_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENC71D_TARGET}
LIBTHEORAENC80_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENC80_TARGET}
LIBTHEORAENC80D_TARGET:= ${TARGETLIBDIR}/${LIBTHEORAENC80D_TARGET}
LIBTHEORADEC_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADEC_TARGET}
LIBTHEORADECD_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADECD_TARGET}
LIBTHEORADEC70_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADEC70_TARGET}
LIBTHEORADEC70D_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADEC70D_TARGET}
LIBTHEORADEC71_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADEC71_TARGET}
LIBTHEORADEC71D_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADEC71D_TARGET}
LIBTHEORADEC80_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADEC80_TARGET}
LIBTHEORADEC80D_TARGET:= ${TARGETLIBDIR}/${LIBTHEORADEC80D_TARGET}
DUMP_VIDEO_TARGET:= ${TARGETBINDIR}/${DUMP_VIDEO_TARGET}
ENCODER_EXAMPLE_TARGET:= ${TARGETBINDIR}/${ENCODER_EXAMPLE_TARGET}
PLAYER_EXAMPLE_TARGET:= ${TARGETBINDIR}/${PLAYER_EXAMPLE_TARGET}
DLL_TARGETS:= ${LIBTHEORADEC_TARGET} ${LIBTHEORAENC_TARGET} \
 ${LIBTHEORADECD_TARGET} ${LIBTHEORAENCD_TARGET} \
 ${LIBTHEORADEC70_TARGET} ${LIBTHEORAENC70_TARGET} \
 ${LIBTHEORADEC70D_TARGET} ${LIBTHEORAENC70D_TARGET} \
 ${LIBTHEORADEC71_TARGET} ${LIBTHEORAENC71_TARGET} \
 ${LIBTHEORADEC71D_TARGET} ${LIBTHEORAENC71D_TARGET} \
 ${LIBTHEORADEC80_TARGET} ${LIBTHEORAENC80_TARGET} \
 ${LIBTHEORADEC80D_TARGET} ${LIBTHEORAENC80D_TARGET}
ALL_TARGETS:= ${DLL_TARGETS} ${DLL_TARGETS:%.dll=%.dll.a} \
 ${DUMP_VIDEO_TARGET} ${ENCODER_EXAMPLE_TARGET} #${PLAYER_EXAMPLE_TARGET}
IMPLIB_TARGETS:= ${DLL_TARGETS:%.dll=%.def} ${DLL_TARGETS:%.dll=%.lib} \
 ${DLL_TARGETS:%.dll=%.exp}

# Targets:
# Everything (default)
all: ${ALL_TARGETS}

# These require Microsoft's lib.exe to build, and so are not made by default.
implibs: ${IMPLIB_TARGETS}

# libtheoradec
${LIBTHEORADEC_TARGET}: ${LIBTHEORADEC_OBJS} ${LIBTHEORADEC_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADEC_OBJS} -logg -lmsvcrt \
         ${LIBTHEORADEC_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def
${LIBTHEORADECD_TARGET}: ${LIBTHEORADECD_OBJS} ${LIBTHEORADECD_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADECD_OBJS} -logg -lmsvcrtd \
         ${LIBTHEORADECD_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def
${LIBTHEORADEC70_TARGET}: ${LIBTHEORADEC_OBJS} ${LIBTHEORADEC70_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADEC_OBJS} -logg -lmsvcr70 \
         ${LIBTHEORADEC70_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def
${LIBTHEORADEC70D_TARGET}: ${LIBTHEORADECD_OBJS} ${LIBTHEORADEC70D_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADECD_OBJS} -logg -lmsvcr70d \
         ${LIBTHEORADEC70D_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def
${LIBTHEORADEC71_TARGET}: ${LIBTHEORADEC_OBJS} ${LIBTHEORADEC71_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADEC_OBJS} -logg -lmsvcr71 \
         ${LIBTHEORADEC71_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def
${LIBTHEORADEC71D_TARGET}: ${LIBTHEORADECD_OBJS} ${LIBTHEORADEC71D_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADECD_OBJS} -logg -lmsvcr71d \
         ${LIBTHEORADEC71D_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def
${LIBTHEORADEC80_TARGET}: ${LIBTHEORADEC_OBJS} ${LIBTHEORADEC80_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADEC_OBJS} -logg -lmsvcr80 \
         ${LIBTHEORADEC80_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def
${LIBTHEORADEC80D_TARGET}: ${LIBTHEORADECD_OBJS} ${LIBTHEORADEC80D_RCO} \
 libtheoradec-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ ${LIBTHEORADECD_OBJS} -logg -lmsvcr80d \
         ${LIBTHEORADEC80D_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoradec-all.def

# libtheoraenc
${LIBTHEORAENC_TARGET}: ${LIBTHEORAENC_OBJS} ${LIBTHEORAENC_RCO} \
 libtheoraenc-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ \
         ${LIBTHEORAENC_OBJS} ${LIBTHEORADEC_TARGET} -logg -lmsvcrt \
         ${LIBTHEORAENC_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoraenc-all.def
${LIBTHEORAENCD_TARGET}: ${LIBTHEORAENCD_OBJS} ${LIBTHEORAENCD_RCO} \
 libtheoraenc-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ \
         ${LIBTHEORAENCD_OBJS} ${LIBTHEORADECD_TARGET} -logg -lmsvcrtd \
         ${LIBTHEORAENCD_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoraenc-all.def
${LIBTHEORAENC70_TARGET}: ${LIBTHEORAENC_OBJS} ${LIBTHEORAENC70_RCO} \
 libtheoraenc-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ \
         ${LIBTHEORAENC_OBJS} ${LIBTHEORADEC70_TARGET} -logg -lmsvcr70 \
         ${LIBTHEORAENC70_RCO} \
         -Wl,--output-def,${@:.dll=.def},--out-implib,$@.a,libtheoraenc-all.def
${LIBTHEORAENC70D_TARGET}: ${LIBTHEORAENCD_OBJS} ${LIBTHEORAENC70D_RCO} \
 libtheoraenc-all.def
	mkdir -p ${TARGETLIBDIR}
	${CC} -shared -o $@ \

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
  texlive-latex-extra,
  texlive-latex-recommended,
  transfig,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/multimedia-team/libtheora.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/libtheora
 Homepage: https://www.theora.org/
@@ -48,9 +48,9 @@
 Section: libdevel
 Depends:
  libogg-dev,
- libtheora0 (= ${binary:Version}),
- libtheoradec1 (= ${binary:Version}),
- libtheoraenc1 (= ${binary:Version}),
+ libtheora1 (= ${binary:Version}),
+ libtheoradec2 (= ${binary:Version}),
+ libtheoraenc2 (= ${binary:Version}),
  ${misc:Depends},
 Description: Theora Video Compression Codec (development files)
  Theora is a fully open, non-proprietary, patent-and-royalty-free,
@@ -73,14 +73,12 @@
  .
  This package contains the documentation about the format and programming.
 
-Package: libtheora0
+Package: libtheora1
 Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
- libtheoradec1 (= ${binary:Version}),
- libtheoraenc1 (= ${binary:Version}),
 Description: Theora Video Compression Codec (shared library - libtheora)
  Theora is an open video codec being developed by the Xiph.org Foundation as
  part of their Ogg project. Theora is originally derived from On2's VP3 codec,
@@ -89,16 +87,12 @@
  .
  This package contains the shared library libtheora.
 
-Package: libtheoraenc1
+Package: libtheoraenc2
 Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Breaks:
- libtheora0 (<< 1.2.0~alpha1+dfsg-1),
-Replaces:
- libtheora0 (<< 1.2.0~alpha1+dfsg-1),
 Description: Theora Video Compression Codec (shared library - libtheoraenc)
  Theora is an open video codec being developed by the Xiph.org Foundation as
  part of their Ogg project. Theora is originally derived from On2's VP3 codec,
@@ -107,16 +101,12 @@
  .
  This package contains the shared library libtheoraenc.
 
-Package: libtheoradec1
+Package: libtheoradec2
 Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Breaks:
- libtheora0 (<< 1.2.0~alpha1+dfsg-1),
-Replaces:
- libtheora0 (<< 1.2.0~alpha1+dfsg-1),
 Description: Theora Video Compression Codec (shared library - libtheoradec)
  Theora is an open video codec being developed by the Xiph.org Foundation as
  part of their Ogg project. Theora is originally derived from On2's VP3 codec,

=== debian/tests/control ===
Tests: test-simple-build-link test-binaries
Depends:
 build-essential,
 debconf,
 libvorbis-dev,
 valgrind  [!armel !riscv64],
 @,
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts="uversionmangle=s/([0-9])(alpha|beta)/$1~$2/,dversionmangle=s/\+dfsg\d+$//,repacksuffix=+dfsg" \
https://downloads.xiph.org/releases/theora/libtheora-([0-9].*)\.tar\.gz debian uupdate
